<?php  if (!defined('BASEPATH')) exit('No direct script access allowed');

function print_options()
{
    $links = get_branding()->get_login_page_links();
    foreach($links as $obj)
    {
        $text = $obj["text"];
        $value = $obj["value"];
        $default = isset($obj["default"]) ? $obj["default"] : false;

        if($default)
            print " <option value=\"$value\" selected>$text</option> \n" ;
        else
            print " <option value=\"$value\">$text</option> \n" ;

    }
};

//Don't allow this page to be embedded inside a frame
header("X-Frame-Options: DENY");
?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">

<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta http-equiv="Pragma" content="no-cache" />
<title><?=get_branding()->get_brand_name()?> Login</title>

<link rel="stylesheet" href="/admin_ui/common/css/ns/ui.css" type="text/css">
<script type="text/javascript" src="/admin_ui/common/js/jquery/jquery-1.4.2.min.js"></script>
<script type="text/javascript" src="/admin_ui/common/js/jquery/jquery.keyfilter-1.7.min.js"></script>
<?php
if ( isset($eula_failed))
{
    print '<script src="/admin_ui/common/js/ns/eula_message.js" type="text/javascript"> </script>';
}
?>
<style type="text/css">
.ns_alert_text a:hover
{
    color: #0000FF !important;
}

</style>
<!--[if IE]>
<style type="text/css">
.login_combo
{
    width: 83%;
}

.login_button_cell
{
    padding-right: 31px;
}
</style>
<![endif]-->
<script language="JavaScript" type="text/javascript">
var display_flag = "block";
if(!document.all)
    display_flag = "table-row";

function checkform ( form )
{
  //getTimezoneOffset() will return (GMT - client) minutes. We need (client - GMT) seconds
  document.form1.timezone_offset.value = new Date().getTimezoneOffset() * -60;

  if (form.username.value === "") {
    show_error("Please enter user name", form.username);
    return false ;
  }
  if (form.password.value === "") {
    show_error("Please enter password", form.password);
    return false ;
  }
  
    form.username.value = addslashes(form.username.value);
    form.password.value = addslashes(form.password.value);
    
    form.username.value = encodeURIComponent(form.username.value);
    form.password.value = encodeURIComponent(form.password.value);
    
  return true ;
}

function addslashes(string) {
    return string.replace(/\\/g, '\\\\').
        replace(/\t/g, '\\t').
        replace(/\n/g, '\\n').
        replace(/\f/g, '\\f').
        replace(/\r/g, '\\r').
        replace(/"/g, '\\"');
}

function checkHTTP() {
    if(location.protocol == "http:")
    {
        return  "To use https, click <a href=javascript:redirectToHTTPS() class=\"ns_login_link\">here</a>";
    }
    else
    {
        $('.ns_login_secure').hide();
        return "";
    }

}

function redirectToHTTPS() {
    location.href = location.href.replace("http", "https");
}

function key_pressed(e)
{
    var keynum;
    if(window.event) // IE
        keynum = e.keyCode;
    else if(e.which) // Netscape/Firefox/Opera
        keynum = e.which;

    if(keynum == 13) //Enter key
        submit_form();

    return true;
}

function submit_form()
{
    if(checkform(document.form1))
    {
        document.form1.submit();
        $("#login_error").hide();
    }
}

function is_options_shown()
{
    var startin_row = document.getElementById("ns_login_options");
    return (!startin_row.style || startin_row.style.display == "" || startin_row.style.display == display_flag);
}

function show_error(message, element)
{
    if(element)
    {
        setTimeout(function(){ element.focus();}, 500);    
    }
    
    if(message)
    {
        $("#login_error").text(message);
        $("#login_error").show();
    }
}

// Mapping used by decodeXml
var escaped_one_to_xml_special_map = {
    '&amp;': '&',
    '&quot;': '"',
    '&lt;': '<',
    '&gt;': '>',
    "&#039;": "'"
};

// To decode the strings which are encoded using php function htmlspecialchars in the backend
function decodeXml(string) {
    return string.replace(/(&quot;|&#039;|&lt;|&gt;|&amp;)/g,
        function(str, item) {
            return escaped_one_to_xml_special_map[item];
    });
}

function isSafari() {
  return /Safari/.test(navigator.userAgent) && /Apple Computer/.test(navigator.vendor);
}

function getSupportedVersionString() {

	try
    {
		var display_string = "Best viewed in IE8+, Firefox 3.6.25+, Chrome v19+ or Safari 5.1.1+(for Mac)";
		var nAgt = navigator.userAgent;
		var browserName  = navigator.appName;
		var fullVersion  = ''+parseFloat(navigator.appVersion); 
		var majorVersion = parseInt(navigator.appVersion,10);
		var nameOffset,verOffset,ix;
		var vendor = null;
		if(navigator.vendor != null)
			vendor = navigator.vendor.toLowerCase();
        
        // User agents for IE http://msdn.microsoft.com/library/ms537503.aspx
        if((nAgt.indexOf("Trident")) != -1)
        {
            if(nAgt.indexOf("rv:") != -1)
            {   
                preg_match('/Trident\/\d{1,2}.\d{1,2}.*rv:([0-9]*)/', nAgt, $matches);
                browserName = "MSIE";
                fullVersion = $matches[1];
            }
            else if ((verOffset=nAgt.indexOf("MSIE"))!=-1)
            {
                browserName = "MSIE";
                fullVersion = nAgt.substring(verOffset+5);
            }
        }
            
		// In Chrome, the true version is after "Chrome" 
		else if ((verOffset=nAgt.indexOf("Chrome"))!=-1) {
		 browserName = "Chrome";
		 fullVersion = nAgt.substring(verOffset+7);
		}
		// In Safari, the true version is after "Safari" or after "Version" 
		else if ((verOffset=nAgt.indexOf("Safari"))!=-1) {
		 browserName = "Safari";
		 fullVersion = nAgt.substring(verOffset+7);
		 if ((verOffset=nAgt.indexOf("Version"))!=-1) 
		   fullVersion = nAgt.substring(verOffset+8);
		}
		// In Firefox, the true version is after "Firefox" 
		else if ((verOffset=nAgt.indexOf("Firefox"))!=-1) {
		 browserName = "Firefox";
		 fullVersion = nAgt.substring(verOffset+8);
		}
		// If you can't detect the browser, return the not-supported warning string
		else 
		{
            $(".ns_browser_not_supported_center").show();
			return;
		}
		// trim the fullVersion string at semicolon/space if present
		if ((ix=fullVersion.indexOf(";"))!=-1)
		   fullVersion=fullVersion.substring(0,ix);
		if ((ix=fullVersion.indexOf(" "))!=-1)
		   fullVersion=fullVersion.substring(0,ix);

		majorVersion = parseInt(''+fullVersion,10);
		if (isNaN(majorVersion)) {
		 fullVersion  = ''+parseFloat(navigator.appVersion); 
		 majorVersion = parseInt(navigator.appVersion,10);
		}
		if( (browserName == "MSIE" && compareFullVersion(fullVersion, "8")) || //IE
			(browserName == "Firefox" && compareFullVersion(fullVersion, "3.6.25"))|| //Firefox
			(browserName == "Chrome" && compareFullVersion(fullVersion, "19")  && vendor != null && vendor.indexOf('google') != -1) || //chrome
			(browserName == "Safari" && compareFullVersion(fullVersion, "5.1.1") && vendor != null && vendor.indexOf('apple') != -1)
																					 && nAgt.toLowerCase().indexOf('mac') != -1) //Safari for mac
		{	
            $(".ns_login_center_content").show();
            return;
        }
		else
        {
            $(".ns_browser_not_supported_center").show();
            return;
        }
	}
	catch(err)
    {
        $(".ns_login_center_content").show();
		return;
	}
    $(".ns_login_center_content").show();
}

function show_login_pane()
{
    $(".ns_browser_not_supported_center").hide();
    $(".ns_login_center_content").show();
}

function compareFullVersion(a, b) //if a>b, return true, else return false
{
    
	if (a === b)
    {
       return true;
    }

    var a_components = a.split(".");
    var b_components = b.split(".");

    var len = Math.min(a_components.length, b_components.length);

    // loop while the components are equal
    for (var i = 0; i < len; i++)
    {
        // A bigger than B
        var val_a = parseInt(a_components[i]);
		var val_b = parseInt(b_components[i]);
		if(isNaN(val_a) || isNaN(val_b))
		 return false;
		if (parseInt(a_components[i]) > parseInt(b_components[i]))
        {
            return true;
        }

        // B bigger than A
        if (parseInt(a_components[i]) < parseInt(b_components[i]))
        {
            return false;
        }
    }

    // If one's a prefix of the other, the longer one is greater.
    if (a_components.length >= b_components.length)
    {
        return true;
    }

    return false;
}

show_eula = function(uname)
{
   $("#eula-text").html(eula_message);
   $("#ns_login_content").addClass("overlay");
   $("#eula-container").show();
   $("#eula-accepted").attr("checked", false);
   $("#username").val(uname)
   
}

close_eula = function()
{
   $("#ns_login_content").removeClass("overlay")
   $("#eula-container").hide();
   
}

continue_eula = function()
{
    var eula_accepted = $("#eula-checkbox").attr("checked");
    if (eula_accepted)
    {
        close_eula();
        $("#eula-accepted").attr("checked", eula_accepted);
    }
    else
    {
        $("#eula_error").show();
    }
}


</script>

</head>
<body class="ns_login_body">
<div id="ns_login_content"></div>
<noscript>
    <div class="center_panel ns_alert_text">
        JavaScript is either disabled in or not supported by the Web browser. To continue logon, use a Web browser that supports JavaScript or enable JavaScript in your current browser.
    </div>
    <div style="display: none">
</noscript>
<div class="ns_login_wrapper">
    <div class="ns_login_inner_wrapper">
	<div class="ns_login_top"></div>
	<div class="ns_login_center">
	    <div class="ns_login_center_content" style="display:none">
		<table align="center" border="0" height="100%">
			<tr>
				<td valign="center" height="100%">
				<table class="" align="center" width="650"  border="0">
                <tr>
                    <td></td>
                    <td></td>
                    <td><span id="login_error" class="login_error"> </span></td>
                </tr>
				<tr>
                    <td class="ns_login_large_product_brand" width="50"> </td>
					<td valign="bottom" height="50%" width="210" class=<?=get_branding()->get_brand_login_css()?>>
					</td>
					<td algin="left" rowspan=2>
						<form name="form1" action="/login/do_login" method="post" autocomplete="off" onsubmit="return checkform(this);" >
							<table  align="top" width="330px" border="0">

								  <tr>
									<td class="ns_grid_text"><label>User Name</label>
									<span class="ns_active">|</span><input type="text" id="username" name="username" class="login_input" onfocus=1></td>
								  </tr>
								  <tr>
									<td class="ns_grid_text"><label>Password</label>
																		<span class="ns_active">|</span><input type="password" name="password" class="login_input">
									</td>
								  </tr>
                                                                  <tr>
                                                                        <td class="ns_grid_text" style="display:none"><input type="checkbox" name="eula" id="eula-accepted" value="TRUE">
									</td>
                                                                  </tr>
							</table>
							<table  align="top" width="330px" border="0">
								  <tr >
									<td><input type="hidden" name="url" value=""></td>
									<td><input type="hidden" name="timezone_offset" value=""></td>
								  </tr>
								   <tr>
									<td align="left" class="login_button_cell">
									  <input type="submit" value="Login" class="login_button rdx_blue_button">
									</td>
								  </tr>
								</table>
						</form>
					</td>
				</tr>
                <tr>
                    <td colspan=2 valign="bottom">
                            <table width="100%" border="0" height="100%" >
							<tr>
                                <td valign="bottom" height="50%">
                                    <div id="ns_login_secure_top" class="ns_login_secure_height"></div>
                                    <div class="ns_login_secure">
                                         <script language="JavaScript" type="text/javascript">
                                            document.writeln(checkHTTP());
                                         </script>
                                    </div>
                                </td>
							</tr>
                            </table>
                    </td>
                </tr>
			</table>
				</td>
			</tr>
		</table>
	    </div>
        <div class="ns_browser_not_supported_center" style="display:none">
        <span> NetScaler</span> 
        <div>
           <div class="">
              <div class="ns_browser_not_supported_center_content">
                <div class="ns_browser_not_supported_center_message"> Your browser is not supported. Please use one of the following browsers</div>
                </br></br>      
                 <table width="100%"> 
                       <tr>
                           <td class="ns_browser_not_supported_browser_icon"><div><img src="/admin_ui/neo/images/internet-explorer.png"><div>8 and above</div></div></td>
                           <td class="ns_browser_not_supported_browser_icon"><div><img src="/admin_ui/neo/images/firefox.png" ><div>3.6.25 and above</div></div></td>
                           <td class="ns_browser_not_supported_browser_icon"><div><img src="/admin_ui/neo/images/chrome.png" ><div>15 and above</div></div></td>
                           <td><div><img src="/admin_ui/neo/images/safari.png" ><div>5.1.3 and above</div></div></td>
                          </tr>
                  </table>
                 <p class="ns_browser_not_supported_center_message"> </br><a href="javascript:show_login_pane()"> Continue, </a> I understand this browser may not be compatible.</p>
              </div>
           </div>
        </div>
        </div>
    </div>
	<div class="ns_login_bottom"></div>
    </div>
    <div>
        <script language="JavaScript" type="text/javascript">
            getSupportedVersionString();
        </script>
	</div>
</div>


<script language="JavaScript" type="text/javascript">
//Don't allow this page to be embedded inside a frame
if(self != top)
{
    document.getElementsByTagName("body")[0].style.display = "none";
    top.location = self.location;
}
else
{   
    <?php if ( isset($loginerror) && $loginerror): ?>
        show_error(decodeXml("<?php echo htmlspecialchars($loginerror); ?>"));  
	<?php endif; ?>
    
    document.form1.username.focus();
}


function input_hints() {
	var inputs = document.getElementsByTagName("input");
	for (var i=0; i<inputs.length; i++){
		if (inputs[i].parentNode.getElementsByTagName("span")[0]) {
				inputs[i].onfocus = function () {
				this.parentNode.getElementsByTagName("span")[0].className= "ns_active ns_active_color";
			}
			inputs[i].onblur = function () {
			this.parentNode.getElementsByTagName("span")[0].className= "ns_active";
			}
		}
	}

	var selects = document.getElementsByTagName("select");
	for (var k=0; k<selects.length; k++){
		if (selects[k].parentNode.getElementsByTagName("span")[0]) {
			selects[k].onfocus = function () {
				this.parentNode.getElementsByTagName("span")[0].className= "ns_active ns_active_color";
			}
			selects[k].onblur = function () {
				this.parentNode.getElementsByTagName("span")[0].className= "ns_active";
			}
		}
	}
}

function set_focus(){
	$("#username").focus();
}
$(document).ready(function(){
   input_hints();
   set_focus();
   
    form.username.value = "";
    form.password.value = "";
   
   <?php
   if ( isset($eula_failed))
    {
        print "var uname = \"$username\";";
        print "show_eula(uname);";
    }
    ?>
 });


</script>
<?php
$this->load->view("common/footer");
?>
<div id="eula-container" class="eula-container show-modal" style="height: 480px;width:670px;display:none;">
            <div class="eula-header">
                <span>End User License Aggrement</span>
                <span id="eula_window_close" class="eula_window_close eula-right">
                    <a href="#noAnchor" onclick=close_eula()>X</a>
                </span>
            </div>
            <div class="eula-content">
                <p> Please read and agree to the following terms and conditions in order to continue</p>
                <div id= "eula-text" class="eula-text"> </div>
                <div class="eula-terms">
                    <input id="eula-checkbox" type="checkbox" style="width : auto;height: auto">I have read and agree to the Terms and Conditions
                </div>
                <div id="eula_error" class= "eula_error_text" style="display:none">
                    In order to use our services, you must agree to Citrix's Terms of Service.
                </div>
                <br/>
                <div class="">
                    <input type="button" value="Continue" onclick=continue_eula() class="button_blue buttons" /> 
                    <input type="button" value="Cancel" onclick=close_eula() class="button_grey buttons"/>
                </div>
            </div>
            </div>
</body>
</html>
